Unit font;

Interface

Uses Graph;
Var FontFile: string;
Procedure NewString;
Procedure DrawString (s: string);
Procedure ExportFont (FileName: string);
Procedure ImportFont (BMPFile,FontFile: string);

Implementation

Type ch = array[0..7] of byte;
Var color: byte;
    f: file of ch;
    a: ch;
    i,j,k,l: byte;

{ 㪢  , ᯮ 䠩 f; 㯭  ᭮ ணࠬ,}
{ᯮ饩 Font, ᪮  ᠭ  Interface; ᯮ ⮫쪮}
{ᠬ 㫥}
Procedure DrawChar (n:byte);
 Begin
  seek (f,n - 1);
  read (f,a);
  for i := 0 to 7 do begin
      k := 128;
      for j := 0 to 7 do begin
          putpixel (getx + j,gety + i,color * ((a[i] mod (k * 2)) div k));
          k := k div 2;
      end;
  end;
 End;

{ந 室   ப}
Procedure NewString;
 Begin
  moveto (0,gety + 8);
 End;

{᭮ 楤  ᮢ ப}
Procedure DrawString;
 Begin
  color := getcolor;
  assign (f,FontFile);
  reset (f);
  while s <> '' do begin
      case ord(s[1]) of
      0..127,176..223,242..255: begin
          outtext (s[1]);{᫨ ᨬ -  ᪠ 㪢, ᯮ㥬 outtext,}
          moveto (getx - 8,gety);{ outtext ⮬᪨ ᬥ頥  }
      end;                       {X  8,   ᠬ ᤢ   }
      {८ࠧ㥬    ASCII  浪  䠢}
      128..133: DrawChar (ord(s[1]) - 127);
      240:      DrawChar (7);{ 祬-  ⠫ 㪢}
      134..165: DrawChar (ord(s[1]) - 126);
      241:      DrawChar (40);
      166..175: DrawChar (ord(s[1]) - 125);
      224..239: DrawChar (ord(s[1]) - 173);
      end;
      delete (s,1,1);
      {ᬥ頥   X  ᫥ 㪢}
      if getx + 8 <= getmaxx then
          moveto (getx + 8,gety)
      else
          NewString;
  end;
  close (f);
 End;

{ᯮ ⥪饣   BMP - 㭮}
Procedure ExportFont;
 Var bmp: file of byte;
 Begin
  {樠㥬 䠩}
  assign (f,FontFile);
  reset (f);
  assign (bmp,FileName);
  rewrite (bmp);
  {  BMP .   ᯮᮡ - ⮬,  Pascal }
  { ஢ ப write (bmp,66,77,94,...), ॡ  }
  {易⥫쭮 ६}
  k:=66;write(bmp,k);k:=77;write(bmp,k);k:=94;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:= 0;write(bmp,k);k:=62;write(bmp,k);k:= 0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=40;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:= 0;write(bmp,k);
  k:=8;write(bmp,k); k:= 1;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=16;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=1;write(bmp,k);k:=0;write(bmp,k);k:=1;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=32;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);k:=255;write(bmp,k);k:=255;write(bmp,k);
  k:=255;write(bmp,k);k:=0;write(bmp,k);
  {  ᮡ⢥  ᪮ }
  for i := 7 downto 0 do begin
      seek (f,0);
      while filepos(f) <> 33 do begin
          read (f,a);
          a[i] := 255 - a[i];
          write (bmp,a[i]);
      end;
      {  - 3 .  ⮫  ࠧࠫ,   室  BMP }
      {   ,    16 ,  ᫨ ப }
      {  16,   ࠢ 㦭 - }
      k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  end;
  for i := 7 downto 0 do begin
      seek (f,33);
      while not eof(f) do begin
          read (f,a);
          a[i] := 255 - a[i];
          write (bmp,a[i]);
      end;
      k:=0;write(bmp,k);k:=0;write(bmp,k);k:=0;write(bmp,k);
  end;
  close (f);
  close (bmp);
 End;

{  BMP - 㭪  }
Procedure ImportFont;
 Var bmp: file of byte;
     t: word;
 Begin
  {樠㥬 䠩}
  assign (f,FontFile);
  rewrite (f);
  assign (bmp,BMPFile);
  reset (bmp);
  {८ࠧ㥬 㭮  ᮢ⨬ 䠩 }
  for l := 0 to 1 do
      for j := 0 to 32 do begin
          for i := 7 downto 0 do begin
              seek (bmp,62 + j + i * 36 + 288 * l);
              read (bmp,k);
              a[7 - i] := 255 - k;
          end;
          write (f,a);
      end;
  close (f);
  close (bmp);
 End;

Begin
 {। 砫 믮 ணࠬ ⠭ ⥪騩   }
 { 㬮砭 'font.dat'}
 FontFile := 'font.dat';
End.